// zEdAXgi\[Xj

#include <stdio.h>
#include <stdlib.h>
#include "Member.h"
#include "CircDblLinkedList.h"

/*--- ̃m[h𓮓Iɐ ---*/
static Dnode* AllocDnode(void)
{
	return calloc(1, sizeof(Dnode));
}

/*--- m[h̊eoɒlݒ ----*/
static void SetDnode(Dnode* n, const Member* x, const Dnode* prev,
	const Dnode* next)
{
	n->data = *x;		// f[^
	n->prev = prev;		// s|C^
	n->next = next;		// 㑱|C^
}

/*--- Xg͋ ---*/
static int IsEmpty(const Dlist* list)
{
	return list->head->next == list->head;
}

/*--- Xg ---*/
void Initialize(Dlist* list)
{
	Dnode* dummyNode = AllocDnode();			// _~[m[h𐶐
	list->head = list->crnt = dummyNode;
	dummyNode->prev = dummyNode->next = dummyNode;
}

/*--- ڃm[h̃f[^\ ---*/
void PrintCurrent(const Dlist* list)
{
	if (IsEmpty(list))
		printf("ڃm[h͂܂B");
	else
		PrintMember(&list->crnt->data);
}

/*--- ڃm[h̃f[^\istj---*/
void PrintLnCurrent(const Dlist* list)
{
	PrintCurrent(list);
	putchar('\n');
}

/*--- ֐compareɂxƈvƔ肳m[hT ---*/
Dnode* Search(Dlist* list, const Member* x,
	int compare(const Member* x, const Member* y))
{
	Dnode* ptr = list->head->next;

	while (ptr != list->head) {
		if (compare(&ptr->data, x) == 0) {
			list->crnt = ptr;
			return ptr;					// T
		}
		ptr = ptr->next;
	}
	return NULL;						// Ts
}

/*--- Sm[h̃f[^Xgɕ\ ---*/
void Print(const Dlist* list)
{
	if (IsEmpty(list))
		puts("m[h܂B");
	else {
		Dnode* ptr = list->head->next;

		puts("yꗗ\z");
		while (ptr != list->head) {
			PrintLnMember(&ptr->data);
			ptr = ptr->next;			// 㑱m[hɒ
		}
	}
}

/*--- Sm[h̃f[^Xg̋tɕ\ ---*/
void PrintReverse(const Dlist* list)
{
	if (IsEmpty(list))
		puts("m[h܂B");
	else {
		Dnode* ptr = list->head->prev;

		puts("yꗗ\z");
		while (ptr != list->head) {
			PrintLnMember(&ptr->data);
			ptr = ptr->prev;			// sm[hɒ
		}
	}
}

/*--- ڃm[hɐi߂ ---*/
int Next(Dlist* list)
{
	if (IsEmpty(list) || list->crnt->next == list->head)
		return 0;						// i߂邱Ƃ͂łȂ
	list->crnt = list->crnt->next;
	return 1;
}

/*--- ڃm[hOɖ߂ ---*/
int Prev(Dlist* list)
{
	if (IsEmpty(list) || list->crnt->prev == list->head)
		return 0;						// ߂Ƃ͂łȂ
	list->crnt = list->crnt->prev;
	return 1;
}

/*--- pwm[h̒Ƀm[h} ---*/
void InsertAfter(Dlist* list, Dnode* p, const Member* x)
{
	Dnode* ptr = AllocDnode();
	Dnode* nxt = p->next;

	p->next = p->next->prev = ptr;
	SetDnode(ptr, x, p, nxt);
	list->crnt = ptr;						// }m[hɒ
}

/*--- 擪Ƀm[h} ---*/
void InsertFront(Dlist* list, const Member* x)
{
	InsertAfter(list, list->head, x);
}

/*--- Ƀm[h} ---*/
void InsertRear(Dlist* list, const Member* x)
{
	InsertAfter(list, list->head->prev, x);
}

/*--- pwm[h폜 ---*/
void Remove(Dlist* list, Dnode* p)
{
	p->prev->next = p->next;
	p->next->prev = p->prev;
	list->crnt = p->prev;		// 폜m[h̐sm[hɒ
	free(p);
	if (list->crnt == list->head)
		list->crnt = list->head->next;
}

/*--- 擪m[h폜 ---*/
void RemoveFront(Dlist* list)
{
	if (!IsEmpty(list))
		Remove(list, list->head->next);
}

/*--- m[h폜 ---*/
void RemoveRear(Dlist* list)
{
	if (!IsEmpty(list))
		Remove(list, list->head->prev);
}

/*--- ڃm[h폜 ---*/
void RemoveCurrent(Dlist* list)
{
	if (list->crnt != list->head)
		Remove(list, list->crnt);
}

/*--- Sm[h폜 ---*/
void Clear(Dlist* list)
{
	while (!IsEmpty(list))			// ɂȂ܂
		RemoveFront(list);			// 擪m[h폜
}

/*--- zEdAXǧn ---*/
void Terminate(Dlist* list)
{
	Clear(list);					// Sm[h폜
	free(list->head);				// _~[m[h폜
}
